:- module(dist_cycles_left_tclp, _).

:- use_package(library(tabling)).
:- use_package(library(t_clpq)).
:- table dist_2/3.

:- use_module(library(format)).


go :- go2.

go2 :-
	dist_limit(Limit),
	cputime(Start),
	findall([X,Y,D], ( D .>. 0, D .<. Limit, dist_2(X,Y,D) ), _List),
	cputime(End),
	sort(_List,Sort),
	length(Sort,Len), print(Len),nl,
	T is End - Start,
	write('% dist_cycles_left_tclp.pl: execution time dist_2 = '), format('~2f',T), 
	write(' milliseconds'), nl.

dist_2(A,B,D) :-
	edge(A,B,D).
dist_2(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	dist_2(A,Z,D1),
	edge(Z,B,D2).

:- include(mainfile_4).
:- include(edge_cycles).
:- include(dist_limit).


cputime(T) :-
	statistics(runtime, [T, _]).

writeln(T) :-
	write(T),
	nl.

