:- module(dist_wo_cycles_left_tab, _).

:- use_package(library(tabling)).
:- table dist_2/3.

:- use_module(library(format)).

go :- go2.

go2 :-
	dist_limit_wo(Limit),
	cputime(Start),
	findall([X, Y, D], (dist_2(X, Y, D), D < Limit), _List),
	cputime(End),
	sort(_List, Sort),
	length(Sort,Len), print(Len),nl,
	T is End - Start,
	write('% dist_wo_cycles_left_tab.pl: execution time dist_2 = '), format('~2f',T),
	write(' milliseconds'), nl.

dist_2(A, B, D) :-
	edge(A, B, D).
dist_2(A, B, D) :-
	dist_2(A, Z, D1),
	edge(Z, B, D2),
	D is D1 + D2.

:- include(mainfile_4).
:- include(edge_wo_cycles).
:- include(dist_limit).

cputime(T) :-
	statistics(runtime, [T, _]).

writeln(T) :-
	write(T),
	nl.

