:- module(dist_wo_cycles_right_tab, _).

:- use_module(library(format)).

:- use_package(library(tabling)).
:- table dist_1/3.

go :- go1.

go1 :-
	dist_limit_wo(Limit),
	cputime(Start),
	findall([X, Y, D], (dist_1(X, Y, D), D < Limit), _List),
	cputime(End),
	sort(_List,Sort),
	length(Sort,Len), print(Len),nl,
	T is End - Start,
	write('% dist_wo_cycles_right_tab.pl: execution time dist_1 = '), format('~2f',T),
	write(' milliseconds'), nl.

dist_1(A, B, D) :-
	edge(A, B, D).
dist_1(A, B, D) :-
	edge(A, Z, D1),
	dist_1(Z, B, D2),
	D is D1 + D2.

:- include(mainfile_4).
:- include(edge_wo_cycles).
:- include(dist_limit).

cputime(T) :-
	statistics(runtime, [T, _]).

writeln(T) :-
	write(T),
	nl.

