:- module(dist_wo_cycles_right_tclp, _).


:- use_package(library(tabling)).
:- use_package(library(t_clpq)).
:- table dist_1/3.

:- use_module(library(format)).

go :- go1.

go1 :-
	dist_limit_wo(Limit),
	cputime(Start),
	findall([X,Y,D], ( D .>. 0, D .<. Limit, dist_1(X,Y,D) ), _List),
	cputime(End),
	sort(_List,Sort),
	length(Sort,Len), print(Len),nl,
	T is End - Start,
	write('% dist_wo_cycles_right_tclp.pl: execution time dist_1 = '), format('~2f',T),
	write(' milliseconds'), nl.

dist_1(A,B,D) :-
	edge(A,B,D).
dist_1(A,B,D) :-
	D1 .>. 0,
	D2 .>. 0,
	D .=. D1 + D2,
	edge(A,Z,D1),
	dist_1(Z,B,D2).

:- include(mainfile_4).
:- include(edge_wo_cycles).
:- include(dist_limit).

cputime(T) :-
	statistics(runtime, [T, _]).

writeln(T) :-
	write(T),
	nl.

